ArrayNode (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.node

## Class ArrayNode

- java.lang.Object
- - org.codehaus.jackson.JsonNode
  - - org.codehaus.jackson.node.BaseJsonNode
    - - org.codehaus.jackson.node.ContainerNode
      - - org.codehaus.jackson.node.ArrayNode

- All Implemented Interfaces:
    Iterable<JsonNode>, JsonSerializable, JsonSerializableWithType

      public final class ArrayNode
      extends ContainerNode

  Node class that represents Arrays mapped from Json content.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.node.ContainerNode

      `ContainerNode.NoNodesIterator, ContainerNode.NoStringsIterator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected ArrayList<JsonNode>` | `_children`

    - ### Fields inherited from class org.codehaus.jackson.JsonNode

      `NO_NODES, NO_STRINGS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ArrayNode(JsonNodeFactory nc)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `JsonNode` | `_set(int index, JsonNode value)`
    `void` | `add(BigDecimal v)` Method for setting value of a field to specified numeric value.
    `void` | `add(boolean v)` Method for setting value of a field to specified String value.
    `void` | `add(Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `add(byte[] v)` Method for setting value of a field to specified binary value
    `void` | `add(double v)` Method for setting value of a field to specified numeric value.
    `void` | `add(Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `add(float v)` Method for setting value of a field to specified numeric value.
    `void` | `add(Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `add(int v)` Method for setting value of a field to specified numeric value.
    `void` | `add(Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `add(JsonNode value)`
    `void` | `add(long v)` Method for setting value of a field to specified numeric value.
    `void` | `add(Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `add(String v)` Method for setting value of a field to specified String value.
    `JsonNode` | `addAll(ArrayNode other)` Method for adding all child nodes of given Array, appending to child nodes this array contains
    `JsonNode` | `addAll(Collection<JsonNode> nodes)` Method for adding given nodes as child nodes of this array node.
    `ArrayNode` | `addArray()` Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
    `protected void` | `addContentsTo(List<JsonNode> dst)`
    `void` | `addNull()`
    `ObjectNode` | `addObject()` Method that will construct an ObjectNode and add it at the end of this array node.
    `void` | `addPOJO(Object value)` Method that will construct a POJONode and add it at the end of this array node.
    `JsonToken` | `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
    `boolean` | `equals(Object o)` Equality for node objects is defined as full (deep) value equality.
    `ObjectNode` | `findParent(String fieldName)` Method for finding a JSON Object that contains specified field, within this node or its descendants.
    `List<JsonNode>` | `findParents(String fieldName, List<JsonNode> foundSoFar)`
    `JsonNode` | `findValue(String fieldName)` Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has.
    `List<JsonNode>` | `findValues(String fieldName, List<JsonNode> foundSoFar)`
    `List<String>` | `findValuesAsText(String fieldName, List<String> foundSoFar)`
    `JsonNode` | `get(int index)` Method for accessing value of the specified element of an array node.
    `JsonNode` | `get(String fieldName)` Method for accessing value of the specified field of an object node.
    `Iterator<JsonNode>` | `getElements()` Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node.
    `int` | `hashCode()`
    `void` | `insert(int index, BigDecimal v)` Method for setting value of a field to specified numeric value.
    `void` | `insert(int index, boolean v)` Method for setting value of a field to specified String value.
    `void` | `insert(int index, Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `insert(int index, byte[] v)` Method for setting value of a field to specified binary value
    `void` | `insert(int index, double v)` Method for setting value of a field to specified numeric value.
    `void` | `insert(int index, Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `insert(int index, float v)` Method for setting value of a field to specified numeric value.
    `void` | `insert(int index, Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `insert(int index, int v)` Method for setting value of a field to specified numeric value.
    `void` | `insert(int index, Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `insert(int index, JsonNode value)` Method for inserting specified child node as an element of this Array.
    `void` | `insert(int index, long v)` Method for setting value of a field to specified numeric value.
    `void` | `insert(int index, Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `void` | `insert(int index, String v)` Method for setting value of a field to specified String value.
    `ArrayNode` | `insertArray(int index)`
    `void` | `insertNull(int index)`
    `ObjectNode` | `insertObject(int index)` Method that will construct an ObjectNode and add it at the end of this array node.
    `void` | `insertPOJO(int index, Object value)` Method that will construct a POJONode and add it at the end of this array node.
    `boolean` | `isArray()`
    `JsonNode` | `path(int index)` This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
    `JsonNode` | `path(String fieldName)` This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
    `JsonNode` | `remove(int index)` Method for removing an entry from this ArrayNode.
    `ArrayNode` | `removeAll()` Method for removing all children container has (if any)
    `void` | `serialize(JsonGenerator jg, SerializerProvider provider)` Method called to serialize node instances using given generator.
    `void` | `serializeWithType(JsonGenerator jg, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
    `JsonNode` | `set(int index, JsonNode value)` Method that will set specified field, replacing old value, if any.
    `int` | `size()` Method that returns number of child nodes this node contains: for Array nodes, number of child elements, for Object nodes, number of fields, and for all other nodes 0.
    `String` | `toString()` Note: marked as abstract to ensure all implementation classes define it properly.

    - ### Methods inherited from class org.codehaus.jackson.node.ContainerNode

      `arrayNode, asText, binaryNode, binaryNode, booleanNode, getValueAsText, isContainerNode, nullNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, objectNode, POJONode, textNode`

    - ### Methods inherited from class org.codehaus.jackson.node.BaseJsonNode

      `findPath, getNumberType, traverse`

    - ### Methods inherited from class org.codehaus.jackson.JsonNode

      `asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, findParents, findValues, findValuesAsText, getBigIntegerValue, getBinaryValue, getBooleanValue, getDecimalValue, getDoubleValue, getFieldNames, getFields, getIntValue, getLongValue, getNumberValue, getPath, getPath, getTextValue, getValueAsBoolean, getValueAsBoolean, getValueAsDouble, getValueAsDouble, getValueAsInt, getValueAsInt, getValueAsLong, getValueAsLong, has, has, isBigDecimal, isBigInteger, isBinary, isBoolean, isDouble, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isObject, isPojo, isTextual, isValueNode, iterator, with`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _children

          protected ArrayList<JsonNode> _children

  - ### Constructor Detail

    - #### ArrayNode

          public ArrayNode(JsonNodeFactory nc)

  - ### Method Detail

    - #### asToken

          public JsonToken asToken()

      Description copied from class: `BaseJsonNode`
      Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)
      Specified by:
        `asToken` in class `ContainerNode`

    - #### isArray

          public boolean isArray()

      Overrides:
        `isArray` in class `JsonNode`
      Returns:
        True if this node represents Json Array

    - #### size

          public int size()

      Description copied from class: `JsonNode`
      Method that returns number of child nodes this node contains: for Array nodes, number of child elements, for Object nodes, number of fields, and for all other nodes 0.
      Specified by:
        `size` in class `ContainerNode`
      Returns:
        For non-container nodes returns 0; for arrays number of contained elements, and for objects number of fields.

    - #### getElements

          public Iterator<JsonNode> getElements()

      Description copied from class: `JsonNode`
      Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node. In case of Object node, field names (keys) are not included, only values. For other types of nodes, returns empty iterator.
      Overrides:
        `getElements` in class `JsonNode`

    - #### get

          public JsonNode get(int index)

      Description copied from class: `JsonNode`
      Method for accessing value of the specified element of an array node. For other nodes, null is always returned.

      For array nodes, index specifies exact location within array and allows for efficient iteration over child elements (underlying storage is guaranteed to be efficiently indexable, i.e. has random-access to elements). If index is less than 0, or equal-or-greater than `node.size()`, null is returned; no exception is thrown for any index.

      Specified by:
        `get` in class `ContainerNode`
      Returns:
        Node that represent value of the specified element, if this node is an array and has specified element. Null otherwise.

    - #### get

          public JsonNode get(String fieldName)

      Description copied from class: `JsonNode`
      Method for accessing value of the specified field of an object node. If this node is not an object (or it does not have a value for specified field name), or if there is no field with such name, null is returned.
      Specified by:
        `get` in class `ContainerNode`
      Returns:
        Node that represent value of the specified field, if this node is an object and has value for the specified field. Null otherwise.

    - #### path

          public JsonNode path(String fieldName)

      Description copied from class: `JsonNode`
      This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.
      Specified by:
        `path` in class `JsonNode`

    - #### path

          public JsonNode path(int index)

      Description copied from class: `JsonNode`
      This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.
      Specified by:
        `path` in class `JsonNode`

    - #### serialize

          public final void serialize(JsonGenerator jg,
                       SerializerProvider provider)
                               throws IOException,
                                      JsonProcessingException

      Description copied from class: `BaseJsonNode`
      Method called to serialize node instances using given generator.
      Specified by:
        `serialize` in interface `JsonSerializable`
      Specified by:
        `serialize` in class `BaseJsonNode`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### serializeWithType

          public void serializeWithType(JsonGenerator jg,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws IOException,
                                        JsonProcessingException

      Description copied from class: `BaseJsonNode`
      Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
      Specified by:
        `serializeWithType` in interface `JsonSerializableWithType`
      Specified by:
        `serializeWithType` in class `BaseJsonNode`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### findValue

          public JsonNode findValue(String fieldName)

      Description copied from class: `JsonNode`
      Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has. If no matching field is found in this node or its descendants, returns null.
      Specified by:
        `findValue` in class `ContainerNode`
      Parameters:
        `fieldName` - Name of field to look for
      Returns:
        Value of first matching node found, if any; null if none

    - #### findValues

          public List<JsonNode> findValues(String fieldName,
                                  List<JsonNode> foundSoFar)

      Specified by:
        `findValues` in class `ContainerNode`

    - #### findValuesAsText

          public List<String> findValuesAsText(String fieldName,
                                      List<String> foundSoFar)

      Specified by:
        `findValuesAsText` in class `ContainerNode`

    - #### findParent

          public ObjectNode findParent(String fieldName)

      Description copied from class: `JsonNode`
      Method for finding a JSON Object that contains specified field, within this node or its descendants. If no matching field is found in this node or its descendants, returns null.
      Specified by:
        `findParent` in class `ContainerNode`
      Parameters:
        `fieldName` - Name of field to look for
      Returns:
        Value of first matching node found, if any; null if none

    - #### findParents

          public List<JsonNode> findParents(String fieldName,
                                   List<JsonNode> foundSoFar)

      Specified by:
        `findParents` in class `ContainerNode`

    - #### set

          public JsonNode set(int index,
                     JsonNode value)

      Method that will set specified field, replacing old value, if any.
      Parameters:
        `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(int)` instead)
      Returns:
        Old value of the field, if any; null if there was no old value.

    - #### add

          public void add(JsonNode value)

    - #### addAll

          public JsonNode addAll(ArrayNode other)

      Method for adding all child nodes of given Array, appending to child nodes this array contains
      Parameters:
        `other` - Array to add contents from
      Returns:
        This node (to allow chaining)
      Since:
        1.3

    - #### addAll

          public JsonNode addAll(Collection<JsonNode> nodes)

      Method for adding given nodes as child nodes of this array node.
      Parameters:
        `nodes` - Nodes to add
      Returns:
        This node (to allow chaining)
      Since:
        1.3

    - #### insert

          public void insert(int index,
                    JsonNode value)

      Method for inserting specified child node as an element of this Array. If index is 0 or less, it will be inserted as the first element; if >= size(), appended at the end, and otherwise inserted before existing element in specified index. No exceptions are thrown for any index.

    - #### remove

          public JsonNode remove(int index)

      Method for removing an entry from this ArrayNode. Will return value of the entry at specified index, if entry existed; null if not.

    - #### removeAll

          public ArrayNode removeAll()

      Description copied from class: `ContainerNode`
      Method for removing all children container has (if any)
      Specified by:
        `removeAll` in class `ContainerNode`
      Returns:
        Container node itself (to allow method call chaining)

    - #### addArray

          public ArrayNode addArray()

      Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
      Returns:
        Newly constructed ArrayNode

    - #### addObject

          public ObjectNode addObject()

      Method that will construct an ObjectNode and add it at the end of this array node.
      Returns:
        Newly constructed ObjectNode

    - #### addPOJO

          public void addPOJO(Object value)

      Method that will construct a POJONode and add it at the end of this array node.

    - #### addNull

          public void addNull()

    - #### add

          public void add(int v)

      Method for setting value of a field to specified numeric value.

    - #### add

          public void add(Integer value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### add

          public void add(long v)

      Method for setting value of a field to specified numeric value.

    - #### add

          public void add(Long value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### add

          public void add(float v)

      Method for setting value of a field to specified numeric value.

    - #### add

          public void add(Float value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### add

          public void add(double v)

      Method for setting value of a field to specified numeric value.

    - #### add

          public void add(Double value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### add

          public void add(BigDecimal v)

      Method for setting value of a field to specified numeric value.

    - #### add

          public void add(String v)

      Method for setting value of a field to specified String value.

    - #### add

          public void add(boolean v)

      Method for setting value of a field to specified String value.

    - #### add

          public void add(Boolean value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### add

          public void add(byte[] v)

      Method for setting value of a field to specified binary value

    - #### insertArray

          public ArrayNode insertArray(int index)

    - #### insertObject

          public ObjectNode insertObject(int index)

      Method that will construct an ObjectNode and add it at the end of this array node.
      Returns:
        Newly constructed ObjectNode

    - #### insertPOJO

          public void insertPOJO(int index,
                        Object value)

      Method that will construct a POJONode and add it at the end of this array node.

    - #### insertNull

          public void insertNull(int index)

    - #### insert

          public void insert(int index,
                    int v)

      Method for setting value of a field to specified numeric value.

    - #### insert

          public void insert(int index,
                    Integer value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### insert

          public void insert(int index,
                    long v)

      Method for setting value of a field to specified numeric value.

    - #### insert

          public void insert(int index,
                    Long value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### insert

          public void insert(int index,
                    float v)

      Method for setting value of a field to specified numeric value.

    - #### insert

          public void insert(int index,
                    Float value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### insert

          public void insert(int index,
                    double v)

      Method for setting value of a field to specified numeric value.

    - #### insert

          public void insert(int index,
                    Double value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### insert

          public void insert(int index,
                    BigDecimal v)

      Method for setting value of a field to specified numeric value.

    - #### insert

          public void insert(int index,
                    String v)

      Method for setting value of a field to specified String value.

    - #### insert

          public void insert(int index,
                    boolean v)

      Method for setting value of a field to specified String value.

    - #### insert

          public void insert(int index,
                    Boolean value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Since:
        1.9

    - #### insert

          public void insert(int index,
                    byte[] v)

      Method for setting value of a field to specified binary value

    - #### addContentsTo

          protected void addContentsTo(List<JsonNode> dst)

      Since:
        1.6

    - #### equals

          public boolean equals(Object o)

      Description copied from class: `JsonNode`
      Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

      Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

      Specified by:
        `equals` in class `JsonNode`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      Description copied from class: `JsonNode`

      Note: marked as abstract to ensure all implementation classes define it properly.

      Specified by:
        `toString` in class `JsonNode`

    - #### _set

          public JsonNode _set(int index,
                      JsonNode value)